## android-platform-external-boringssl 13~preview2

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

# Defer enabling C and CXX languages.
project(BoringSSL NONE)

if(WIN32)
  # On Windows, prefer cl over gcc if both are available. By default most of
  # the CMake generators prefer gcc, even on Windows.
  set(CMAKE_GENERATOR_CC cl)
endif()

include(sources.cmake)

enable_language(C)
enable_language(CXX)

# This is a dummy target which all other targets depend on (manually - see other
# CMakeLists.txt files). This gives us a hook to add any targets which need to
# run before all other targets.
add_custom_target(global_target)

if(ANDROID)
  # Android-NDK CMake files reconfigure the path and so Go and Perl won't be
  # found. However, ninja will still find them in $PATH if we just name them.
  if(NOT PERL_EXECUTABLE)
    set(PERL_EXECUTABLE "perl")
  endif()
  if(NOT GO_EXECUTABLE)
    set(GO_EXECUTABLE "go")
  endif()
else()
  find_package(Perl REQUIRED)
  find_program(GO_EXECUTABLE go)
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "Linux" AND NOT CMAKE_CROSSCOMPILING)
  find_package(PkgConfig QUIET)
  if (PkgConfig_FOUND)
    pkg_check_modules(LIBUNWIND libunwind-generic)
    if(LIBUNWIND_FOUND)
      add_definitions(-DBORINGSSL_HAVE_LIBUNWIND)
    else()
      message("libunwind not found. Disabling unwind tests.")
    endif()
  else()
    message("pkgconfig not found. Disabling unwind tests.")
  endif()
endif()

if(NOT GO_EXECUTABLE)
  message(FATAL_ERROR "Could not find Go")
endif()

if(USE_CUSTOM_LIBCXX)
  set(BORINGSSL_ALLOW_CXX_RUNTIME 1)
endif()

if(BORINGSSL_ALLOW_CXX_RUNTIME)
  add_definitions(-DBORINGSSL_ALLOW_CXX_RUNTIME)
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_LOWER)
if(NOT FIPS)
  if(CMAKE_BUILD_TYPE_LOWER STREQUAL "relwithassert" OR
     NOT CMAKE_BUILD_TYPE_LOWER MATCHES "rel")
    add_definitions(-DBORINGSSL_DISPATCH_TEST)
    # CMake automatically connects include_directories to the NASM
    # command-line, but not add_definitions.
    set(CMAKE_ASM_NASM_FLAGS "${CMAKE_ASM_NASM_FLAGS} -DBORINGSSL_DISPATCH_TEST")
  endif()
endif()

# Add a RelWithAsserts build configuration. It is the same as Release, except it
# does not define NDEBUG, so asserts run.
foreach(VAR CMAKE_C_FLAGS CMAKE_CXX_FLAGS CMAKE_ASM_FLAGS)
  string(REGEX REPLACE "(^| )[/-]DNDEBUG( |$)" " " "${VAR}_RELWITHASSERTS"
         "${${VAR}_RELEASE}")
endforeach()

if(BORINGSSL_PREFIX AND BORINGSSL_PREFIX_SYMBOLS)
  add_definitions(-DBORINGSSL_PREFIX=${BORINGSSL_PREFIX})
  # CMake automatically connects include_directories to the NASM command-line,
  # but not add_definitions.
  set(CMAKE_ASM_NASM_FLAGS "${CMAKE_ASM_NASM_FLAGS} -DBORINGSSL_PREFIX=${BORINGSSL_PREFIX}")

  # Use "symbol_prefix_include" to store generated header files
  include_directories(${CMAKE_CURRENT_BINARY_DIR}/symbol_prefix_include)
  add_custom_command(
    OUTPUT symbol_prefix_include/boringssl_prefix_symbols.h
           symbol_prefix_include/boringssl_prefix_symbols_asm.h
           symbol_prefix_include/boringssl_prefix_symbols_nasm.inc
    COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/symbol_prefix_include
    COMMAND ${GO_EXECUTABLE} run ${CMAKE_CURRENT_SOURCE_DIR}/util/make_prefix_headers.go -out ${CMAKE_CURRENT_BINARY_DIR}/symbol_prefix_include ${BORINGSSL_PREFIX_SYMBOLS}
    DEPENDS util/make_prefix_headers.go
            ${CMAKE_BINARY_DIR}/${BORINGSSL_PREFIX_SYMBOLS})

  # add_dependencies needs a target, not a file, so we add an intermediate
  # target.
  add_custom_target(
    boringssl_prefix_symbols
    DEPENDS symbol_prefix_include/boringssl_prefix_symbols.h
            symbol_prefix_include/boringssl_prefix_symbols_asm.h
            symbol_prefix_include/boringssl_prefix_symbols_nasm.inc)
  add_dependencies(global_target boringssl_prefix_symbols)
elseif(BORINGSSL_PREFIX OR BORINGSSL_PREFIX_SYMBOLS)
  message(FATAL_ERROR "Must specify both or neither of BORINGSSL_PREFIX and BORINGSSL_PREFIX_SYMBOLS")
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  set(CLANG 1)
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
  set(EMSCRIPTEN 1)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CLANG)
  # Note clang-cl is odd and sets both CLANG and MSVC. We base our configuration
  # primarily on our normal Clang one.
  set(C_CXX_FLAGS "-Werror -Wformat=2 -Wsign-compare -Wmissing-field-initializers -Wwrite-strings -Wvla -Wshadow")
  if(MSVC)
    # clang-cl sets different default warnings than clang. It also treats -Wall
    # as -Weverything, to match MSVC. Instead -W3 is the alias for -Wall.
    # See http://llvm.org/viewvc/llvm-project?view=revision&revision=319116
    set(C_CXX_FLAGS "${C_CXX_FLAGS} -W3 -Wno-unused-parameter -fmsc-version=1900")
    # googletest suppresses warning C4996 via a pragma, but clang-cl does not
    # honor it. Suppress it here to compensate. See https://crbug.com/772117.
    set(C_CXX_FLAGS "${C_CXX_FLAGS} -Wno-deprecated-declarations")
  else()
    if(EMSCRIPTEN)
      # emscripten's emcc/clang does not accept the "-ggdb" flag.
      set(C_CXX_FLAGS "${C_CXX_FLAGS} -g")
    else()
      set(C_CXX_FLAGS "${C_CXX_FLAGS} -ggdb")
    endif()

    set(C_CXX_FLAGS "${C_CXX_FLAGS} -Wall -fvisibility=hidden -fno-common")
  endif()

  if(CLANG)
    set(C_CXX_FLAGS "${C_CXX_FLAGS} -Wnewline-eof -fcolor-diagnostics")
  else()
    # GCC (at least 4.8.4) has a bug where it'll find unreachable free() calls
    # and declare that the code is trying to free a stack pointer.
    set(C_CXX_FLAGS "${C_CXX_FLAGS} -Wno-free-nonheap-object")
  endif()

  if(CLANG OR NOT "7.0.0" VERSION_GREATER CMAKE_C_COMPILER_VERSION)
    set(C_CXX_FLAGS "${C_CXX_FLAGS} -Wimplicit-fallthrough")
  endif()

  if(CMAKE_COMPILER_IS_GNUCXX)
    set(C_CXX_FLAGS "${C_CXX_FLAGS} -Wformat-signedness")
  endif()

  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${C_CXX_FLAGS} -Wmissing-prototypes -Wold-style-definition -Wstrict-prototypes")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${C_CXX_FLAGS} -Wmissing-declarations")

  if(NOT MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
    if(APPLE)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
    endif()
    if(NOT BORINGSSL_ALLOW_CXX_RUNTIME)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-exceptions -fno-rtti")
    endif()
  endif()

  # In GCC, -Wmissing-declarations is the C++ spelling of -Wmissing-prototypes
  # and using the wrong one is an error. In Clang, -Wmissing-prototypes is the
  # spelling for both and -Wmissing-declarations is some other warning.
  #
  # https://gcc.gnu.org/onlinedocs/gcc-7.1.0/gcc/Warning-Options.html#Warning-Options
  # https://clang.llvm.org/docs/DiagnosticsReference.html#wmissing-prototypes
  # https://clang.llvm.org/docs/DiagnosticsReference.html#wmissing-declarations
  if(CLANG)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wmissing-prototypes")
  endif()
elseif(MSVC)
  set(MSVC_DISABLED_WARNINGS_LIST
      "C4061" # enumerator 'identifier' in switch of enum 'enumeration' is not
              # explicitly handled by a case label
              # Disable this because it flags even when there is a default.
      "C4100" # 'exarg' : unreferenced formal parameter
      "C4127" # conditional expression is constant
      "C4200" # nonstandard extension used : zero-sized array in
              # struct/union.
      "C4204" # nonstandard extension used: non-constant aggregate initializer
      "C4221" # nonstandard extension used : 'identifier' : cannot be
              # initialized using address of automatic variable
      "C4242" # 'function' : conversion from 'int' to 'uint8_t',
              # possible loss of data
      "C4244" # 'function' : conversion from 'int' to 'uint8_t',
              # possible loss of data
      "C4267" # conversion from 'size_t' to 'int', possible loss of data
      "C4371" # layout of class may have changed from a previous version of the
              # compiler due to better packing of member '...'
      "C4388" # signed/unsigned mismatch
      "C4296" # '>=' : expression is always true
      "C4350" # behavior change: 'std::_Wrap_alloc...'
      "C4365" # '=' : conversion from 'size_t' to 'int',
              # signed/unsigned mismatch
      "C4389" # '!=' : signed/unsigned mismatch
      "C4464" # relative include path contains '..'
      "C4510" # 'argument' : default constructor could not be generated
      "C4512" # 'argument' : assignment operator could not be generated
      "C4514" # 'function': unreferenced inline function has been removed
      "C4548" # expression before comma has no effect; expected expression with
              # side-effect" caused by FD_* macros.
      "C4610" # struct 'argument' can never be instantiated - user defined
              # constructor required.
      "C4623" # default constructor was implicitly defined as deleted
      "C4625" # copy constructor could not be generated because a base class
              # copy constructor is inaccessible or deleted
      "C4626" # assignment operator could not be generated because a base class
              # assignment operator is inaccessible or deleted
      "C4628" # digraphs not supported with -Ze
      "C4668" # 'symbol' is not defined as a preprocessor macro, replacing with
              # '0' for 'directives'
              # Disable this because GTest uses it everywhere.
      "C4706" # assignment within conditional expression
      "C4710" # 'function': function not inlined
      "C4711" # function 'function' selected for inline expansion
      "C4800" # 'int' : forcing value to bool 'true' or 'false'
              # (performance warning)
      "C4820" # 'bytes' bytes padding added after construct 'member_name'
      "C5026" # move constructor was implicitly defined as deleted
      "C5027" # move assignment operator was implicitly defined as deleted
      "C5045" # Compiler will insert Spectre mitigation for memory load if
              # /Qspectre switch specified
      )
  set(MSVC_LEVEL4_WARNINGS_LIST
      # See https://connect.microsoft.com/VisualStudio/feedback/details/1217660/warning-c4265-when-using-functional-header
      "C4265" # class has virtual functions, but destructor is not virtual
      )
  string(REPLACE "C" " -wd" MSVC_DISABLED_WARNINGS_STR
                            ${MSVC_DISABLED_WARNINGS_LIST})
  string(REPLACE "C" " -w4" MSVC_LEVEL4_WARNINGS_STR
                            ${MSVC_LEVEL4_WARNINGS_LIST})
  set(CMAKE_C_FLAGS   "-utf-8 -Wall -WX ${MSVC_DISABLED_WARNINGS_STR} ${MSVC_LEVEL4_WARNINGS_STR}")
  set(CMAKE_CXX_FLAGS "-utf-8 -Wall -WX ${MSVC_DISABLED_WARNINGS_STR} ${MSVC_LEVEL4_WARNINGS_STR}")
endif()

if(WIN32)
  add_definitions(-D_HAS_EXCEPTIONS=0)
  add_definitions(-DWIN32_LEAN_AND_MEAN)
  add_definitions(-DNOMINMAX)
  # Allow use of fopen.
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
  # VS 2017 and higher supports STL-only warning suppressions.
  # A bug in CMake < 3.13.0 may cause the space in this value to
  # cause issues when building with NASM. In that case, update CMake.
  add_definitions("-D_STL_EXTRA_DISABLED_WARNINGS=4774 4987")
endif()

if(CMAKE_COMPILER_IS_GNUCXX)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c11")
endif()

# pthread_rwlock_t on Linux requires a feature flag. However, it should not be
# set on Apple platforms, where it instead disables APIs we use. See compat(5)
# and sys/cdefs.h.
if(NOT WIN32 AND NOT APPLE)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_XOPEN_SOURCE=700")
endif()

if(FUZZ)
  if(NOT CLANG)
    message(FATAL_ERROR "You need to build with Clang for fuzzing to work")
  endif()

  if(CMAKE_C_COMPILER_VERSION VERSION_LESS "6.0.0")
    message(FATAL_ERROR "You need Clang ≥ 6.0.0")
  endif()

  add_definitions(-DBORINGSSL_UNSAFE_DETERMINISTIC_MODE)
  set(RUNNER_ARGS "-deterministic")

  if(NOT NO_FUZZER_MODE)
    add_definitions(-DBORINGSSL_UNSAFE_FUZZER_MODE)
    set(RUNNER_ARGS ${RUNNER_ARGS} "-fuzzer" "-shim-config" "fuzzer_mode.json")
  endif()

  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address,fuzzer-no-link -fsanitize-coverage=edge,indirect-calls")

=== debian/changelog ===
android-platform-external-boringssl (13~preview2-7ubuntu3) kinetic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Make sure to export the binaries in a known dwarf format, to avoid
      failures in dh_dwz and dh_strip with llvm-14

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 28 Jun 2022 08:38:37 +0200

android-platform-external-boringssl (13~preview2-7) unstable; urgency=medium

  * Team upload.
  * [again] Use lld as linker on available platforms.

 -- Roger Shimizu <rosh@debian.org>  Tue, 28 Jun 2022 02:04:55 +0900

android-platform-external-boringssl (13~preview2-6) unstable; urgency=medium

  * Team upload.
  * Use lld as linker on available platforms.
  * debian/patches/0[12]: Add patch description.
  * d/source/lintian-overrides: Adapt new rule to source filename.
  * Add debian/upstream/metadata.

 -- Roger Shimizu <rosh@debian.org>  Mon, 27 Jun 2022 19:38:58 +0900

android-platform-external-boringssl (13~preview2-5) unstable; urgency=medium

  * Team upload.
  * debian/*.mk: Fix ftbfs for mips*el.

 -- Roger Shimizu <rosh@debian.org>  Sun, 19 Jun 2022 02:14:20 +0900

android-platform-external-boringssl (13~preview2-4) unstable; urgency=medium

  * Team upload.
  * Add patch from upstream tag platform-tools-33.0.1.
  * Move -pie from debian/rules to debian/*.mk executable build.
  * [ubuntu] debian/rules: ignore dh_dwz error.
  * Use lld as linker when available.

 -- Roger Shimizu <rosh@debian.org>  Sun, 19 Jun 2022 00:21:10 +0900

android-platform-external-boringssl (13~preview2-3ubuntu1) kinetic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Ignore dwz failures, failing since clang-14 default

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 13 Jun 2022 09:11:54 +0200

android-platform-external-boringssl (13~preview2-3) unstable; urgency=medium

  * Team upload.
  * d/rules: Move common CPPFLAGS from d/*.mk to d/rules
  * d/control: Move android-libboringssl-dev from Architecture: all to
    each arch being supported.

 -- Roger Shimizu <rosh@debian.org>  Mon, 13 Jun 2022 00:52:06 +0900

android-platform-external-boringssl (13~preview2-2ubuntu1) kinetic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Ignore dwz failures, failing since clang-14 default

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 09 Jun 2022 11:28:01 +0200

android-platform-external-boringssl (13~preview2-2) unstable; urgency=medium

  * Team upload.
  * debian/*.mk: Fix ftbfs for armel.

 -- Roger Shimizu <rosh@debian.org>  Tue, 07 Jun 2022 18:35:21 +0900

android-platform-external-boringssl (13~preview2-1ubuntu1) kinetic; urgency=medium

  * Ignore dwz failures, failing since clang-14 default

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 07 Jun 2022 14:59:10 +0200

android-platform-external-boringssl (13~preview2-1) unstable; urgency=medium

  * Team upload.
  * debian/*.mk: Using the "gnu11" variant means we don't need _XOPEN_SOURCE.
    Additionally, using C11 makes the faster refcount implementation
    available. This setting is from upstream.

 -- Roger Shimizu <rosh@debian.org>  Mon, 06 Jun 2022 21:09:55 +0900

android-platform-external-boringssl (13~preview2-1~exp1) unstable; urgency=medium

  * Team upload.
  * New upstream version 13~preview2
  * debian/patches: Refresh patches.
  * debian/sources.mk: Update by script.

 -- Roger Shimizu <rosh@debian.org>  Wed, 01 Jun 2022 04:00:31 +0900

android-platform-external-boringssl (12.1.0+r5-2) unstable; urgency=medium

  * Team upload.
  * debian/tests/control: Limit architecture.

 -- Roger Shimizu <rosh@debian.org>  Tue, 31 May 2022 01:41:52 +0900

android-platform-external-boringssl (12.1.0+r5-1) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.
  * debian/rules: Build and test only for -arch build.

 -- Roger Shimizu <rosh@debian.org>  Mon, 30 May 2022 19:06:02 +0900

android-platform-external-boringssl (12.1.0+r5-1~exp10) experimental; urgency=medium

  * Team upload.
  * debian/crypto_test.mk: Fallback to gcc for mips64el.
    Thanks to Adrian Bunk for fixing this test for mips64el.

 -- Roger Shimizu <rosh@debian.org>  Sun, 29 May 2022 16:50:06 +0900

android-platform-external-boringssl (12.1.0+r5-1~exp9) experimental; urgency=medium

  * Team upload.
  * debian/control: Update Depends version.
  * debian/tests/control: Add autopkgtest test.

 -- Roger Shimizu <rosh@debian.org>  Sat, 28 May 2022 18:38:29 +0900

android-platform-external-boringssl (12.1.0+r5-1~exp8) experimental; urgency=medium

  * Team upload.
  * debian/rules:
    - Disable building bssl-tools for Hurd.
    - Add -pie to LDFLAGS to enhance the hardening.
  * debian/control:
    - Add android-boringssl package to include the tool.
  * debian/copyright & debian/source/lintian-overrides:
    - Adapt with new upstream.

 -- Roger Shimizu <rosh@debian.org>  Thu, 26 May 2022 01:00:02 +0900

android-platform-external-boringssl (12.1.0+r5-1~exp7) experimental; urgency=medium

  * Team upload.
  * debian/tool_test.mk and debian/rules:
    - Add bssl-tool to build.
  * debian/rules:
    - Still run failing test for mips64el, just ignore the result.

 -- Roger Shimizu <rosh@debian.org>  Mon, 23 May 2022 21:01:59 +0900

android-platform-external-boringssl (12.1.0+r5-1~exp6) experimental; urgency=medium

  * Team upload.
  * Disable crypto_test for mips64el temporarily.
  * Split test_support as an independant library.
  * d/rules:
    - Make dependency driven makefile rules.

 -- Roger Shimizu <rosh@debian.org>  Mon, 16 May 2022 23:23:41 +0900

android-platform-external-boringssl (12.1.0+r5-1~exp5) experimental; urgency=medium

  * Team upload.
  * Update eureka.mk and source it in debian/*.mk
  * d/{crypto,ssl}_test.mk:
    - Link with atomic for armel.
  * d/patches:
    - Update 01 patch to fix x32.

 -- Roger Shimizu <rosh@debian.org>  Mon, 16 May 2022 02:25:59 +0900



=== debian/control ===
Source: android-platform-external-boringssl
Section: libs
Priority: optional
Maintainer: Android Tools Maintainers <android-tools-devel@lists.alioth.debian.org>
Uploaders: Kai-Chung Yan <seamlikok@gmail.com>
Build-Depends:
 clang [amd64 i386 armel armhf arm64 mipsel mips64el ppc64el riscv64],
 debhelper-compat (= 12),
 dh-exec,
 libgtest-dev,
 lld [amd64 i386 armel armhf arm64 mipsel mips64el ppc64el],
Standards-Version: 4.5.0
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/android-tools-team/android-platform-external-boringssl.git
Vcs-Browser: https://salsa.debian.org/android-tools-team/android-platform-external-boringssl
Homepage: https://android.googlesource.com/platform/external/boringssl

Package: android-libboringssl
Architecture: armel armhf arm64 amd64 i386 ppc64el mipsel mips64el hurd-i386 ia64 kfreebsd-amd64 kfreebsd-i386 riscv64 sh4 x32
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Google's internal fork of OpenSSL for the Android SDK
 The Android SDK builds against a static version of BoringSSL,
 Google's internal fork of OpenSSL.  This package should never be used
 for anything but Android SDK packages that already depend on it.
 .
 BoringSSL arose because Google used OpenSSL for many years in various
 ways and, over time, built up a large number of patches that were
 maintained while tracking upstream OpenSSL. As Google’s product
 portfolio became more complex, more copies of OpenSSL sprung up and
 the effort involved in maintaining all these patches in multiple
 places was growing steadily.
 .
 This is the Android AOSP fork of BoringSSL which is designed to be
 used by Android and its SDK.  BoringSSL is only ever statically linked
 into apps, and pinned to a commit version.  Upstream has no official
 releases of BoringSSL on its own, so it must be included separately
 for each project that uses it.

Package: android-libboringssl-dev
Section: libdevel
Architecture: armel armhf arm64 amd64 i386 ppc64el mipsel mips64el hurd-i386 ia64 kfreebsd-amd64 kfreebsd-i386 riscv64 sh4 x32
Multi-Arch: foreign
Depends: ${misc:Depends},
         android-libboringssl (= ${binary:Version}),
Description: Google's internal fork of OpenSSL for the Android SDK - devel
 The Android SDK builds against a static version of BoringSSL,
 Google's internal fork of OpenSSL.  This package should never be used
 for anything but Android SDK packages that already depend on it.
 .
 BoringSSL arose because Google used OpenSSL for many years in various
 ways and, over time, built up a large number of patches that were
 maintained while tracking upstream OpenSSL. As Google’s product
 portfolio became more complex, more copies of OpenSSL sprung up and
 the effort involved in maintaining all these patches in multiple
 places was growing steadily.
 .
 This is the Android AOSP fork of BoringSSL which is designed to be
 used by Android and its SDK.  BoringSSL is only ever statically linked
 into apps, and pinned to a commit version.  Upstream has no official
 releases of BoringSSL on its own, so it must be included separately
 for each project that uses it.
 .
 This package contains the development files.

Package: android-boringssl
Section: utils
Architecture: armel armhf arm64 amd64 i386 ppc64el mipsel mips64el ia64 kfreebsd-amd64 kfreebsd-i386 riscv64 sh4 x32
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Google's internal fork of OpenSSL for the Android SDK - tool
 The Android SDK builds against a static version of BoringSSL,
 Google's internal fork of OpenSSL.  This package should never be used
 for anything but Android SDK packages that already depend on it.
 .
 BoringSSL arose because Google used OpenSSL for many years in various
 ways and, over time, built up a large number of patches that were
 maintained while tracking upstream OpenSSL. As Google’s product
 portfolio became more complex, more copies of OpenSSL sprung up and
 the effort involved in maintaining all these patches in multiple
 places was growing steadily.
 .
 This is the Android AOSP fork of BoringSSL which is designed to be
 used by Android and its SDK.  BoringSSL is only ever statically linked
 into apps, and pinned to a commit version.  Upstream has no official
 releases of BoringSSL on its own, so it must be included separately
 for each project that uses it.
 .
 This package contains the boringssl command line tool.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

## Security Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
export DEB_CFLAGS_MAINT_APPEND = -fPIC
export DEB_CXXFLAGS_MAINT_APPEND = -fPIC
export DEB_LDFLAGS_MAINT_APPEND = -fPIC
export DEB_CPPFLAGS_MAINT_APPEND = -DNDEBUG -UDEBUG \
  -DBORINGSSL_ANDROID_SYSTEM \
  -DBORINGSSL_IMPLEMENTATION \
  -DBORINGSSL_SHARED_LIBRARY \
  -DOPENSSL_SMALL \
  -fmessage-length=0 \
  -fno-exceptions \
  -fno-strict-aliasing \
  -no-canonical-prefixes \

ifneq (, $(shell which clang))
  export CC = clang
  export CXX = clang++
  export DEB_CFLAGS_MAINT_APPEND += -gdwarf-4
  export DEB_CXXFLAGS_MAINT_APPEND += -gdwarf-4
endif
ifneq (, $(shell which lld))
  export DEB_LDFLAGS_MAINT_APPEND += -fuse-ld=lld -Wl,--build-id=sha1
endif

%:
	dh $@

# Since this depends on golang-go, not gccgo, so let's update manually
# Depends: golang-go
update-sources-mk:
	dpkg-source --before-build .
	python3 src/util/generate_build_files.py eureka
	cp eureka.mk debian/sources.mk

lib%.so: debian/lib%.mk
	dh_auto_build --buildsystem=makefile -- --file=$<

compiler_test: debian/compiler_test.mk
	dh_auto_build --buildsystem=makefile -- --file=$<
	LD_LIBRARY_PATH=debian/out debian/out/$@

%_test: debian/%_test.mk libtest_support.so libcrypto.so libssl.so
	dh_auto_build --buildsystem=makefile -- --file=$<

ifneq ($(DEB_HOST_ARCH), hurd-i386)
override_dh_auto_build-arch: compiler_test tool_test
else
# TODO: tool_test build fails on hurd-i386 currently
override_dh_auto_build-arch: compiler_test
endif
	dh_auto_build

ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
override_dh_auto_test-arch: crypto_test ssl_test
ifneq ($(DEB_HOST_ARCH), hurd-i386)
	LD_LIBRARY_PATH=debian/out debian/out/bssl-tool genrsa
endif
	LD_LIBRARY_PATH=debian/out debian/out/crypto_test
	LD_LIBRARY_PATH=debian/out debian/out/ssl_test
endif

override_dh_dwz:
	dh_dwz || true

=== debian/watch ===
# uscan --download-version 12.1.0_r5

version=4
opts="pagemangle=s%\">android-%\.tar\.gz\">android-%g;s%/\+/refs/tags/%/+archive/%g, \
      oversionmangle=s%_r(\d+|\d+\.\d+|\w)%+r$1%, \
      repack, compression=xz, \
      filenamemangle=s%[\w\/\.:]+\+archive\/android-%@PACKAGE@-%" \
https://android.googlesource.com/platform/external/boringssl/+refs \
    [\w\/]+\+archive\/android-([0-9\.]+_r\d+|\d+\.\d+|\w)\.tar\.gz

## android-platform-external-boringssl 13.0.0%2Br24

=== debian/changelog ===
android-platform-external-boringssl (13.0.0+r24-2+rpi1) bookworm-staging; urgency=medium

  [changes brought forward from 10.0.0+r36-1+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Tue, 19 Jan 2021 16:01:40 +0000]
  * Mark asm as armv6 to avoid setting off armv7 contamination checker.
  * set __ARM_MAX_ARCH__ to 6.
  * disable HWAES define.
  * disable GHASH_ASM_ARM define.

 -- Raspbian forward porter <root@raspbian.org>  Fri, 20 Jan 2023 23:35:28 +0000

android-platform-external-boringssl (13.0.0+r24-2) unstable; urgency=medium

  * debian/patches: Refresh again.
  * debian/rules: Add script to import new upstream.
  * debian/lintian-overrides: Add mips*el specific tag.

 -- Roger Shimizu <rosh@debian.org>  Tue, 17 Jan 2023 21:08:43 -0800

android-platform-external-boringssl (13.0.0+r24-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Use correct machine-readable copyright file URI.
  * Bump debhelper from old 12 to 13.
  * Update standards version to 4.6.1, no changes needed.

  [ Roger Shimizu ]
  * New upstream release 13.0.0+r24
  * debian/*.lintian-overrides: Update to make more accurate.
  * debian/copyright:
    - Remove non-existing entries.
    - Fix typo.

 -- Roger Shimizu <rosh@debian.org>  Mon, 16 Jan 2023 02:04:16 -0800

android-platform-external-boringssl (13.0.0+r11-3) unstable; urgency=medium

  * Team upload.
  * Add patch to skip failing test (Closes: #1026716)
  * Move package description to source package

 -- Jochen Sprickerhof <jspricke@debian.org>  Tue, 27 Dec 2022 22:11:29 +0100

android-platform-external-boringssl (13.0.0+r11-2) unstable; urgency=medium

  * debian/rules: Export gdwarf-4 so we align with ubuntu patches.

 -- Roger Shimizu <rosh@debian.org>  Tue, 15 Nov 2022 22:28:07 -0800

android-platform-external-boringssl (13.0.0+r11-1) unstable; urgency=medium

  * New upstream release 13.0.0+r11
  * debian/patches: Remove backport patch.
  * debian/copyright: Update file list.
  * debian/sources.mk: Update by script.
  * debian/control: Add myself as uploader.

 -- Roger Shimizu <rosh@debian.org>  Sat, 29 Oct 2022 01:58:01 -0700

## android-platform-external-boringssl 13.0.0+r11

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: libs
 Priority: optional
 Maintainer: Android Tools Maintainers <android-tools-devel@lists.alioth.debian.org>
-Uploaders: Kai-Chung Yan <seamlikok@gmail.com>
+Uploaders: Roger Shimizu <rosh@debian.org>
 Build-Depends:
  clang [amd64 i386 armel armhf arm64 mipsel mips64el ppc64el riscv64],
  debhelper-compat (= 12),

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 include /usr/share/dpkg/pkg-info.mk
 
 ## Security Hardening
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export DEB_CFLAGS_MAINT_APPEND = -fPIC
 export DEB_CXXFLAGS_MAINT_APPEND = -fPIC
 export DEB_LDFLAGS_MAINT_APPEND = -fPIC
@@ -21,11 +21,9 @@
 ifneq (, $(shell which clang))
   export CC = clang
   export CXX = clang++
-  export DEB_CFLAGS_MAINT_APPEND += -gdwarf-4
-  export DEB_CXXFLAGS_MAINT_APPEND += -gdwarf-4
 endif
 ifneq (, $(shell which lld))
-  export DEB_LDFLAGS_MAINT_APPEND += -fuse-ld=lld -Wl,--build-id=sha1
+  export DEB_LDFLAGS_MAINT_APPEND += -fuse-ld=lld
 endif
 
 %:
